import processing.video.*;

import ddf.minim.*;
import ddf.minim.ugens.*;
Minim minim;
AudioOutput out;
Oscil fm;

Capture cam;

float smoothdark =255;
float easing = 0.2;
int index;

void setup() 
{
  size(640, 480);
  
  minim = new Minim( this );
  out   = minim.getLineOut();
  Oscil wave = new Oscil( 60, 0.8, Waves.TRIANGLE );
  fm   = new Oscil( 10, 2, Waves.SINE );
  fm.offset.setLastValue( 200 );
  fm.patch( wave.frequency );
  wave.patch( out );

  String[] cameras = Capture.list();

  if (cameras.length == 0) 
  {
    println("There are no cameras available for capture.");
    exit();
  } 
  else {
    println("Available cameras:");
    for (int i = 0; i < cameras.length; i++) 
    {
      println(cameras[i]);
    }
    cam = new Capture(this, cameras[0]);
    cam.start();
  }
}

void draw() 
{
  if (cam.available() == true) 
  {
    cam.read();
    image(cam, 0, 0);
    
    int darkestX = 0; // X-coordinate of the brightest video pixel
    int darkestY = 0; // Y-coordinate of the brightest video pixel
    float darkestValue = 20; // Brightness of the brightest video pixel
    
    cam.loadPixels();
    
    for (int y = 0; y < cam.height; y++) 
    {
      //for (int x = 0; x < cam.width; x++) 
      //{
        int pixelValue = get(width/2,y);
        float pixelDarkness = brightness(pixelValue);
       
        if (pixelDarkness < darkestValue) 
        {
          darkestValue = pixelDarkness;
          darkestY = y;
          //darkestX = x;
        }
        index++;
      //}
    }
    stroke(255,0,200);
    
    float target = darkestY;
    float d = target - smoothdark;
    if(abs(d) > 1) 
    {
      smoothdark += d * easing;
    }
    line(width/2-30,smoothdark,width/2+30,smoothdark);
    line(width/2,smoothdark-30,width/2,smoothdark+30);
    println(smoothdark);
    
    float modulateAmount = map( smoothdark, 0, height, 0.1, 600 );
    float modulateFrequency = map( smoothdark, 0, height, 1, 100 );
  
  fm.frequency.setLastValue( modulateFrequency * 100 );
  fm.amplitude.setLastValue( modulateAmount * 100);
  }
  
}
